Index: src/sas/sascalc/data_util/odict.py
===================================================================
--- src/sas/sascalc/data_util/odict.py	(revision b699768550de9d4b35b087234ec1d2a461922bab)
+++ src/sas/sascalc/data_util/odict.py	(revision 574adc767a9e86744546f8edd6a23dc4f81914ad)
@@ -39,15 +39,15 @@
     """
     A class of dictionary that keeps the insertion order of keys.
-    
+
     All appropriate methods return keys, items, or values in an ordered way.
-    
+
     All normal dictionary methods are available. Update and comparison is
     restricted to other OrderedDict objects.
-    
+
     Various sequence methods are available, including the ability to explicitly
     mutate the key ordering.
-    
+
     __contains__ tests:
-    
+
     >>> d = OrderedDict(((1, 3),))
     >>> 1 in d
@@ -55,7 +55,7 @@
     >>> 4 in d
     0
-    
+
     __getitem__ tests:
-    
+
     >>> OrderedDict(((1, 3), (3, 2), (2, 1)))[2]
     1
@@ -63,14 +63,14 @@
     Traceback (most recent call last):
     KeyError: 4
-    
+
     __len__ tests:
-    
+
     >>> len(OrderedDict())
     0
     >>> len(OrderedDict(((1, 3), (3, 2), (2, 1))))
     3
-    
+
     get tests:
-    
+
     >>> d = OrderedDict(((1, 3), (3, 2), (2, 1)))
     >>> d.get(1)
@@ -82,7 +82,7 @@
     >>> d
     OrderedDict([(1, 3), (3, 2), (2, 1)])
-    
+
     has_key tests:
-    
+
     >>> d = OrderedDict(((1, 3), (3, 2), (2, 1)))
     >>> d.has_key(1)
@@ -96,9 +96,9 @@
         Create a new ordered dictionary. Cannot init from a normal dict,
         nor from kwargs, since items order is undefined in those cases.
-        
+
         If the ``strict`` keyword argument is ``True`` (``False`` is the
         default) then when doing slice assignment - the ``OrderedDict`` you are
         assigning from *must not* contain any keys in the remaining dict.
-        
+
         >>> OrderedDict()
         OrderedDict([])
@@ -283,5 +283,5 @@
         """
         Used for __repr__ and __str__
-        
+
         >>> r1 = repr(OrderedDict((('a', 'b'), ('c', 'd'), ('e', 'f'))))
         >>> r1
@@ -321,5 +321,5 @@
         >>> d
         OrderedDict([(0, 1), (1, 2), (5, 6), (7, 8), (3, 4)])
-        
+
         >>> a = OrderedDict(((0, 1), (1, 2), (2, 3)), strict=True)
         >>> a[3] = 4
@@ -345,10 +345,10 @@
         >>> a
         OrderedDict([(3, 4), (2, 3), (1, 2), (0, 1)])
-        
+
         >>> d = OrderedDict([(0, 1), (1, 2), (2, 3), (3, 4)])
         >>> d[:1] = 3
         Traceback (most recent call last):
         TypeError: slice assignment requires an OrderedDict
-        
+
         >>> d = OrderedDict([(0, 1), (1, 2), (2, 3), (3, 4)])
         >>> d[:1] = OrderedDict([(9, 8)])
@@ -444,5 +444,5 @@
         """
         Implemented so that access to ``sequence`` raises a warning.
-        
+
         >>> d = OrderedDict()
         >>> d.sequence
@@ -463,5 +463,5 @@
         """
         To allow deepcopy to work with OrderedDict.
-        
+
         >>> from copy import deepcopy
         >>> a = OrderedDict([(1, 1), (2, 2), (3, 3)])
@@ -490,7 +490,7 @@
     def items(self):
         """
-        ``items`` returns a list of tuples representing all the 
+        ``items`` returns a list of tuples representing all the
         ``(key, value)`` pairs in the dictionary.
-        
+
         >>> d = OrderedDict(((1, 3), (3, 2), (2, 1)))
         >>> d.items()
@@ -505,5 +505,5 @@
         """
         Return a list of keys in the ``OrderedDict``.
-        
+
         >>> d = OrderedDict(((1, 3), (3, 2), (2, 1)))
         >>> d.keys()
@@ -515,8 +515,8 @@
         """
         Return a list of all the values in the OrderedDict.
-        
+
         Optionally you can pass in a list of values, which will replace the
         current list. The value list must be the same len as the OrderedDict.
-        
+
         >>> d = OrderedDict(((1, 3), (3, 2), (2, 1)))
         >>> d.values()
@@ -596,5 +596,5 @@
         """
         No dict.pop in Python 2.2, gotta reimplement it
-        
+
         >>> d = OrderedDict(((1, 3), (3, 2), (2, 1)))
         >>> d.pop(3)
@@ -612,5 +612,5 @@
         """
         if len(args) > 1:
-            raise TypeError, ('pop expected at most 2 arguments, got %s' %
+            raise TypeError('pop expected at most 2 arguments, got %s' %
                 (len(args) + 1))
         if key in self:
@@ -628,5 +628,5 @@
         Delete and return an item specified by index, not a random one as in
         dict. The index is -1 by default (the last item).
-        
+
         >>> d = OrderedDict(((1, 3), (3, 2), (2, 1)))
         >>> d.popitem()
@@ -674,5 +674,5 @@
         """
         Update from another OrderedDict or sequence of (key, value) pairs
-        
+
         >>> d = OrderedDict(((1, 0), (0, 1)))
         >>> d.update(OrderedDict(((1, 3), (3, 2), (2, 1))))
@@ -706,9 +706,9 @@
         """
         Rename the key for a given value, without modifying sequence order.
-        
+
         For the case where new_key already exists this raise an exception,
         since if new_key exists, it is ambiguous as to what happens to the
         associated values, and the position of new_key in the sequence.
-        
+
         >>> od = OrderedDict()
         >>> od['a'] = 1
@@ -732,5 +732,5 @@
             raise ValueError("New key already exists: %r" % new_key)
         # rename sequence entry
-        value = self[old_key] 
+        value = self[old_key]
         old_idx = self._sequence.index(old_key)
         self._sequence[old_idx] = new_key
@@ -742,8 +742,8 @@
         """
         This method allows you to set the items in the dict.
-        
+
         It takes a list of tuples - of the same sort returned by the ``items``
         method.
-        
+
         >>> d = OrderedDict()
         >>> d.setitems(((3, 1), (2, 3), (1, 2)))
@@ -760,8 +760,8 @@
         replace the current set. This must contain the same set of keys, but
         need not be in the same order.
-        
+
         If you pass in new keys that don't match, a ``KeyError`` will be
         raised.
-        
+
         >>> d = OrderedDict(((1, 3), (3, 2), (2, 1)))
         >>> d.keys()
@@ -791,7 +791,7 @@
         You can pass in a list of values, which will replace the
         current list. The value list must be the same len as the OrderedDict.
-        
+
         (Or a ``ValueError`` is raised.)
-        
+
         >>> d = OrderedDict(((1, 3), (3, 2), (2, 1)))
         >>> d.setvalues((1, 2, 3))
@@ -813,5 +813,5 @@
         """
         Return the position of the specified key in the OrderedDict.
-        
+
         >>> d = OrderedDict(((1, 3), (3, 2), (2, 1)))
         >>> d.index(3)
@@ -826,8 +826,8 @@
         """
         Takes ``index``, ``key``, and ``value`` as arguments.
-        
+
         Sets ``key`` to ``value``, so that ``key`` is at position ``index`` in
         the OrderedDict.
-        
+
         >>> d = OrderedDict(((1, 3), (3, 2), (2, 1)))
         >>> d.insert(0, 4, 0)
@@ -850,5 +850,5 @@
         """
         Reverse the order of the OrderedDict.
-        
+
         >>> d = OrderedDict(((1, 3), (3, 2), (2, 1)))
         >>> d.reverse()
@@ -861,8 +861,8 @@
         """
         Sort the key order in the OrderedDict.
-        
+
         This method takes the same arguments as the ``list.sort`` method on
         your version of Python.
-        
+
         >>> d = OrderedDict(((4, 1), (2, 2), (3, 3), (1, 4)))
         >>> d.sort()
@@ -876,5 +876,5 @@
     """
     Custom object for accessing the keys of an OrderedDict.
-    
+
     Can be called like the normal ``OrderedDict.keys`` method, but also
     supports indexing and sequence methods.
@@ -897,5 +897,5 @@
         You cannot assign to keys, but you can do slice assignment to re-order
         them.
-        
+
         You can only do slice assignment if the new set of keys is a reordering
         of the original set.
@@ -967,5 +967,5 @@
     """
     Custom object for accessing the items of an OrderedDict.
-    
+
     Can be called like the normal ``OrderedDict.items`` method, but also
     supports indexing and sequence methods.
@@ -1077,5 +1077,5 @@
     """
     Custom object for accessing the values of an OrderedDict.
-    
+
     Can be called like the normal ``OrderedDict.values`` method, but also
     supports indexing and sequence methods.
@@ -1099,5 +1099,5 @@
         """
         Set the value at position i to value.
-        
+
         You can only do slice assignment to values if you supply a sequence of
         equal length to the slice you are replacing.
@@ -1168,10 +1168,10 @@
     Experimental version of OrderedDict that has a custom object for ``keys``,
     ``values``, and ``items``.
-    
+
     These are callable sequence objects that work as methods, or can be
     manipulated directly as sequences.
-    
+
     Test for ``keys``, ``items`` and ``values``.
-    
+
     >>> d = SequenceOrderedDict(((1, 2), (2, 3), (3, 4)))
     >>> d
@@ -1293,5 +1293,5 @@
     >>> d
     SequenceOrderedDict([(1, 1), (2, 2), (3, 3)])
-    
+
     >>> d = SequenceOrderedDict(((1, 2), (2, 3), (3, 4)))
     >>> d
Index: src/sas/sascalc/data_util/registry.py
===================================================================
--- src/sas/sascalc/data_util/registry.py	(revision 3ece5dd0ab4005c590b101addcee167772e5954b)
+++ src/sas/sascalc/data_util/registry.py	(revision dc8d1c2838582489b1d85751d7e27f7348c8685c)
@@ -101,5 +101,5 @@
         extlist = [ext for ext in self.extensions() if path.endswith(ext)]
         # Sort matching extensions by decreasing order of length
-        extlist.sort(lambda a,b: len(a)<len(b))
+        extlist.sort(key=len)
         # Combine loaders for matching extensions into one big list
         loaders = []
Index: src/sas/sascalc/data_util/uncertainty.py
===================================================================
--- src/sas/sascalc/data_util/uncertainty.py	(revision 9a5097cd1c76689d1f997b85ba43d12a95d8f243)
+++ src/sas/sascalc/data_util/uncertainty.py	(revision 574adc767a9e86744546f8edd6a23dc4f81914ad)
@@ -2,10 +2,10 @@
 Uncertainty propagation class for arithmetic, log and exp.
 
-Based on scalars or numpy vectors, this class allows you to store and 
+Based on scalars or numpy vectors, this class allows you to store and
 manipulate values+uncertainties, with propagation of gaussian error for
 addition, subtraction, multiplication, division, power, exp and log.
 
 Storage properties are determined by the numbers used to set the value
-and uncertainty.  Be sure to use floating point uncertainty vectors 
+and uncertainty.  Be sure to use floating point uncertainty vectors
 for inplace operations since numpy does not do automatic type conversion.
 Normal operations can use mixed integer and floating point.  In place
@@ -18,6 +18,7 @@
 
 import numpy as np
-import err1d
-from formatnum import format_uncertainty
+
+from .import err1d
+from .formatnum import format_uncertainty
 
 __all__ = ['Uncertainty']
@@ -28,5 +29,5 @@
     # Make standard deviation available
     def _getdx(self): return np.sqrt(self.variance)
-    def _setdx(self,dx): 
+    def _setdx(self,dx):
         # Direct operation
         #    variance = dx**2
@@ -38,10 +39,10 @@
     # Constructor
     def __init__(self, x, variance=None):
-        self.x, self.variance = x, variance    
- 
+        self.x, self.variance = x, variance
+
     # Numpy array slicing operations
-    def __len__(self): 
+    def __len__(self):
         return len(self.x)
-    def __getitem__(self,key): 
+    def __getitem__(self,key):
         return Uncertainty(self.x[key],self.variance[key])
     def __setitem__(self,key,value):
@@ -137,5 +138,5 @@
     def __idiv__(self, other): return self.__itruediv__(other)
 
-        
+
     # Unary ops
     def __neg__(self):
@@ -151,5 +152,5 @@
             return format_uncertainty(self.x,np.sqrt(self.variance))
         else:
-            return [format_uncertainty(v,dv) 
+            return [format_uncertainty(v,dv)
                     for v,dv in zip(self.x,np.sqrt(self.variance))]
     def __repr__(self):
@@ -219,5 +220,5 @@
     z = a/4
     assert z.x == 5./4 and z.variance == 3./4**2
-    
+
     # Reverse scalar operations
     z = 4+a
@@ -229,5 +230,5 @@
     z = 4/a
     assert z.x == 4./5 and abs(z.variance - 3./5**4 * 4**2) < 1e-15
-    
+
     # Power operations
     z = a**2
@@ -250,5 +251,5 @@
     assert z.x == 5./4 and abs(z.variance - (3./5**2 + 2./4**2)*(5./4)**2) < 1e-15
 
-    # ===== Inplace operations =====    
+    # ===== Inplace operations =====
     # Scalar operations
     y = a+0; y += 4
@@ -308,5 +309,5 @@
     assert (z.x == 5./4).all()
     assert (abs(z.variance - (3./5**2 + 2./4**2)*(5./4)**2) < 1e-15).all()
-    
+
     # printing; note that sqrt(3) ~ 1.7
     assert str(Uncertainty(5,3)) == "5.0(17)"
Index: src/sas/sascalc/dataloader/__init__.py
===================================================================
--- src/sas/sascalc/dataloader/__init__.py	(revision b699768550de9d4b35b087234ec1d2a461922bab)
+++ src/sas/sascalc/dataloader/__init__.py	(revision 574adc767a9e86744546f8edd6a23dc4f81914ad)
@@ -1,3 +1,3 @@
-from data_info import *
-from manipulations import *
-from readers import *
+from .data_info import *
+from .manipulations import *
+from .readers import *
Index: src/sas/sascalc/dataloader/data_info.py
===================================================================
--- src/sas/sascalc/dataloader/data_info.py	(revision 17e257b538be266d4161c1dfa5ee2bea9ef364f2)
+++ src/sas/sascalc/dataloader/data_info.py	(revision 574adc767a9e86744546f8edd6a23dc4f81914ad)
@@ -716,5 +716,5 @@
                 self.y_unit = '1/cm'
         except: # the data is not recognized/supported, and the user is notified
-            raise(TypeError, 'data not recognized, check documentation for supported 1D data formats')
+            raise TypeError('data not recognized, check documentation for supported 1D data formats')
 
     def __str__(self):
@@ -796,5 +796,5 @@
                 len(self.y) != len(other.y):
                 msg = "Unable to perform operation: data length are not equal"
-                raise ValueError, msg
+                raise ValueError(msg)
             # Here we could also extrapolate between data points
             TOLERANCE = 0.01
@@ -802,5 +802,5 @@
                 if math.fabs((self.x[i] - other.x[i])/self.x[i]) > TOLERANCE:
                     msg = "Incompatible data sets: x-values do not match"
-                    raise ValueError, msg
+                    raise ValueError(msg)
 
             # Check that the other data set has errors, otherwise
@@ -876,5 +876,5 @@
         if not isinstance(other, Data1D):
             msg = "Unable to perform operation: different types of data set"
-            raise ValueError, msg
+            raise ValueError(msg)
         return True
 
@@ -948,5 +948,5 @@
 
         if len(self.detector) > 0:
-            raise RuntimeError, "Data2D: Detector bank already filled at init"
+            raise RuntimeError("Data2D: Detector bank already filled at init")
 
     def __str__(self):
@@ -1020,12 +1020,12 @@
                 len(self.qy_data) != len(other.qy_data):
                 msg = "Unable to perform operation: data length are not equal"
-                raise ValueError, msg
+                raise ValueError(msg)
             for ind in range(len(self.data)):
                 if math.fabs((self.qx_data[ind] - other.qx_data[ind])/self.qx_data[ind]) > TOLERANCE:
                     msg = "Incompatible data sets: qx-values do not match: %s %s" % (self.qx_data[ind], other.qx_data[ind])
-                    raise ValueError, msg
+                    raise ValueError(msg)
                 if math.fabs((self.qy_data[ind] - other.qy_data[ind])/self.qy_data[ind]) > TOLERANCE:
                     msg = "Incompatible data sets: qy-values do not match: %s %s" % (self.qy_data[ind], other.qy_data[ind])
-                    raise ValueError, msg
+                    raise ValueError(msg)
 
             # Check that the scales match
@@ -1108,5 +1108,5 @@
         if not isinstance(other, Data2D):
             msg = "Unable to perform operation: different types of data set"
-            raise ValueError, msg
+            raise ValueError(msg)
         return True
 
Index: src/sas/sascalc/dataloader/file_reader_base_class.py
===================================================================
--- src/sas/sascalc/dataloader/file_reader_base_class.py	(revision ae69c690bae8eb1cae0c6902dd71755dda9710f8)
+++ src/sas/sascalc/dataloader/file_reader_base_class.py	(revision 7b50f14eb38e44aca64b1a233e5b996b05f5dc0c)
@@ -6,15 +6,23 @@
 
 import os
+import sys
 import re
 import logging
+from abc import abstractmethod
+
 import numpy as np
-from abc import abstractmethod
-from loader_exceptions import NoKnownLoaderException, FileContentsException,\
+from .loader_exceptions import NoKnownLoaderException, FileContentsException,\
     DataReaderException, DefaultReaderException
-from data_info import Data1D, Data2D, DataInfo, plottable_1D, plottable_2D,\
+from .data_info import Data1D, Data2D, DataInfo, plottable_1D, plottable_2D,\
     combine_data_info_with_plottable
 
 logger = logging.getLogger(__name__)
 
+if sys.version_info[0] < 3:
+    def decode(s):
+        return s
+else:
+    def decode(s):
+        return s.decode() if isinstance(s, bytes) else s
 
 class FileReader(object):
@@ -78,4 +86,26 @@
         # Return a list of parsed entries that data_loader can manage
         return self.output
+
+    def nextline(self):
+        """
+        Returns the next line in the file as a string.
+        """
+        #return self.f_open.readline()
+        return decode(self.f_open.readline())
+
+    def nextlines(self):
+        """
+        Returns the next line in the file as a string.
+        """
+        for line in self.f_open:
+            #yield line
+            yield decode(line)
+
+    def readall(self):
+        """
+        Returns the entire file as a string.
+        """
+        #return self.f_open.read()
+        return decode(self.f_open.read())
 
     def handle_error_message(self, msg):
Index: src/sas/sascalc/dataloader/loader.py
===================================================================
--- src/sas/sascalc/dataloader/loader.py	(revision dcb91cf83e474bdbe1c788d87690ca5f5e7841cb)
+++ src/sas/sascalc/dataloader/loader.py	(revision dc8d1c2838582489b1d85751d7e27f7348c8685c)
@@ -26,12 +26,14 @@
 import time
 from zipfile import ZipFile
+
 from sas.sascalc.data_util.registry import ExtensionRegistry
+
 # Default readers are defined in the readers sub-module
-import readers
-from loader_exceptions import NoKnownLoaderException, FileContentsException,\
+from . import readers
+from .loader_exceptions import NoKnownLoaderException, FileContentsException,\
     DefaultReaderException
-from readers import ascii_reader
-from readers import cansas_reader
-from readers import cansas_reader_HDF5
+from .readers import ascii_reader
+from .readers import cansas_reader
+from .readers import cansas_reader_HDF5
 
 logger = logging.getLogger(__name__)
@@ -73,4 +75,5 @@
         try:
             return super(Registry, self).load(path, format=format)
+        #except Exception: raise  # for debugging, don't use fallback loader
         except NoKnownLoaderException as nkl_e:
             pass  # Try the ASCII reader
@@ -327,5 +330,5 @@
         extlist = [ext for ext in self.extensions() if path.endswith(ext)]
         # Sort matching extensions by decreasing order of length
-        extlist.sort(lambda a, b: len(a) < len(b))
+        extlist.sort(key=len)
         # Combine loaders for matching extensions into one big list
         writers = []
@@ -341,5 +344,5 @@
         # Raise an error if there are no matching extensions
         if len(writers) == 0:
-            raise ValueError, "Unknown file type for " + path
+            raise ValueError("Unknown file type for " + path)
         # All done
         return writers
@@ -360,5 +363,5 @@
             try:
                 return fn(path, data)
-            except:
+            except Exception:
                 pass  # give other loaders a chance to succeed
         # If we get here it is because all loaders failed
Index: src/sas/sascalc/dataloader/manipulations.py
===================================================================
--- src/sas/sascalc/dataloader/manipulations.py	(revision 324e0bf8b73f2240c3c9fc343111f7c06cd3bca8)
+++ src/sas/sascalc/dataloader/manipulations.py	(revision 574adc767a9e86744546f8edd6a23dc4f81914ad)
@@ -26,5 +26,5 @@
 
 #from data_info import plottable_2D
-from data_info import Data1D
+from .data_info import Data1D
 
 
Index: src/sas/sascalc/dataloader/readers/__init__.py
===================================================================
--- src/sas/sascalc/dataloader/readers/__init__.py	(revision 488f3a5d892488fd37274dc8ae6ce49780434f37)
+++ src/sas/sascalc/dataloader/readers/__init__.py	(revision 574adc767a9e86744546f8edd6a23dc4f81914ad)
@@ -1,2 +1,2 @@
 # Method to associate extensions to default readers
-from associations import read_associations
+from .associations import read_associations
Index: src/sas/sascalc/dataloader/readers/abs_reader.py
===================================================================
--- src/sas/sascalc/dataloader/readers/abs_reader.py	(revision ad92c5a96ecb73ee7094bafca363a6a7a61a530d)
+++ src/sas/sascalc/dataloader/readers/abs_reader.py	(revision 46cf4c9afade5339c43974291e5429d30610b75b)
@@ -11,10 +11,11 @@
 
 import logging
+
 import numpy as np
-from sas.sascalc.dataloader.file_reader_base_class import FileReader
-from sas.sascalc.dataloader.data_info import DataInfo, plottable_1D, Data1D,\
-    Detector
-from sas.sascalc.dataloader.loader_exceptions import FileContentsException,\
-    DefaultReaderException
+
+from sas.sascalc.data_util.nxsunit import Converter
+from ..file_reader_base_class import FileReader
+from ..data_info import DataInfo, plottable_1D, Data1D, Detector
+from ..loader_exceptions import FileContentsException, DefaultReaderException
 
 logger = logging.getLogger(__name__)
@@ -31,20 +32,15 @@
     # List of allowed extensions
     ext = ['.abs']
-    
+
     def get_file_contents(self):
-        """ 
+        """
         Get the contents of the file
-        
+
         :raise RuntimeError: when the file can't be opened
         :raise ValueError: when the length of the data vectors are inconsistent
         """
-        buff = self.f_open.read()
+        buff = self.readall()
         filepath = self.f_open.name
         lines = buff.splitlines()
-        self.has_converter = True
-        try:
-            from sas.sascalc.data_util.nxsunit import Converter
-        except:
-            self.has_converter = False
         self.output = []
         self.current_datainfo = DataInfo()
@@ -75,6 +71,5 @@
                 try:
                     value = float(line_toks[1])
-                    if self.has_converter and \
-                            self.current_datainfo.source.wavelength_unit != 'A':
+                    if self.current_datainfo.source.wavelength_unit != 'A':
                         conv = Converter('A')
                         self.current_datainfo.source.wavelength = conv(value,
@@ -89,5 +84,5 @@
                 try:
                     value = float(line_toks[3])
-                    if self.has_converter and detector.distance_unit != 'm':
+                    if detector.distance_unit != 'm':
                         conv = Converter('m')
                         detector.distance = conv(value,
@@ -95,5 +90,5 @@
                     else:
                         detector.distance = value
-                except:
+                except Exception:
                     msg = "ABSReader cannot read SDD from %s" % filepath
                     self.current_datainfo.errors.append(msg)
@@ -110,6 +105,5 @@
                 try:
                     value = float(line_toks[5])
-                    if self.has_converter and \
-                            self.current_datainfo.sample.thickness_unit != 'cm':
+                    if self.current_datainfo.sample.thickness_unit != 'cm':
                         conv = Converter('cm')
                         self.current_datainfo.sample.thickness = conv(value,
@@ -134,5 +128,5 @@
 
                 # Bin size
-                if self.has_converter and detector.pixel_size_unit != 'mm':
+                if detector.pixel_size_unit != 'mm':
                     conv = Converter('mm')
                     detector.pixel_size.x = conv(5.08,
@@ -146,10 +140,10 @@
                 # Store beam center in distance units
                 # Det 640 x 640 mm
-                if self.has_converter and detector.beam_center_unit != 'mm':
+                if detector.beam_center_unit != 'mm':
                     conv = Converter('mm')
                     detector.beam_center.x = conv(center_x * 5.08,
                                      units=detector.beam_center_unit)
                     detector.beam_center.y = conv(center_y * 5.08,
-                                    units=detector.beam_center_unit)
+                                     units=detector.beam_center_unit)
                 else:
                     detector.beam_center.x = center_x * 5.08
Index: src/sas/sascalc/dataloader/readers/anton_paar_saxs_reader.py
===================================================================
--- src/sas/sascalc/dataloader/readers/anton_paar_saxs_reader.py	(revision fafe52a82bebe8d8a20bfb820388c964aa3c4b7b)
+++ src/sas/sascalc/dataloader/readers/anton_paar_saxs_reader.py	(revision a5bd87a4eae90ea636d8e5a5ddb6cd6370e029b3)
@@ -63,5 +63,5 @@
         ## Reinitialize the class when loading a new data file to reset all class variables
         self.reset_state()
-        buff = self.f_open.read()
+        buff = self.readall()
         self.raw_data = buff.splitlines()
         self.read_data()
Index: src/sas/sascalc/dataloader/readers/ascii_reader.py
===================================================================
--- src/sas/sascalc/dataloader/readers/ascii_reader.py	(revision f994e8b1aa05e01ca78e9e360337d188540cd1bc)
+++ src/sas/sascalc/dataloader/readers/ascii_reader.py	(revision f7d720f97952cbb67364a7712043a0cf53bc7a06)
@@ -45,5 +45,5 @@
         """
 
-        buff = self.f_open.read()
+        buff = self.readall()
         filepath = self.f_open.name
         lines = buff.splitlines()
@@ -130,5 +130,5 @@
                 # Reset # of lines of data candidates
                 candidate_lines = 0
-        
+
         if not is_data:
             self.set_all_to_none()
Index: src/sas/sascalc/dataloader/readers/associations.py
===================================================================
--- src/sas/sascalc/dataloader/readers/associations.py	(revision ce8c7bd4870bc1b63b94231ed8f227410e8faee1)
+++ src/sas/sascalc/dataloader/readers/associations.py	(revision 574adc767a9e86744546f8edd6a23dc4f81914ad)
@@ -40,5 +40,5 @@
     """
     # For each FileType entry, get the associated reader and extension
-    for ext, reader in settings.iteritems():
+    for ext, reader in settings.items():
         if reader is not None and ext is not None:
             # Associate the extension with a particular reader
@@ -47,9 +47,9 @@
             # and remove the extra line below.
             try:
-                exec "import %s" % reader
-                exec "loader.associate_file_type('%s', %s)" % (ext.lower(),
-                                                                reader)
-                exec "loader.associate_file_type('%s', %s)" % (ext.upper(),
-                                                                reader)
+                exec("from . import %s" % reader)
+                exec("loader.associate_file_type('%s', %s)"
+                     % (ext.lower(), reader))
+                exec("loader.associate_file_type('%s', %s)"
+                     % (ext.upper(), reader))
             except:
                 msg = "read_associations: skipping association"
